program runasroot;

{$mode objfpc}{$H+}

uses
  {$IFDEF UNIX}{$IFDEF UseCThreads}
  cthreads,
  {$ENDIF}{$ENDIF}
  Classes, SysUtils, CustApp
  { you can add units after this };

type

  { _runasroot }

  _runasroot = class(TCustomApplication)
  protected
    procedure DoRun; override;
  public
    constructor Create(TheOwner: TComponent); override;
    procedure WriteHelp; virtual;
  end;

{ _runasroot }

const geteuid = 'geteuid';
var
   S: String;
   F: File of Byte;
   b: Byte;
   TM: TMemoryStream;
   i, j: Integer;

Function Copy(S: String; Start, Count: Integer): String;
var i, Stop: Integer;
Begin
     Result := '';
     Stop := (Start + Count) - 1;
     For i := Start To Stop Do Result := Result + S[i];
end;

Function GetPos(Where, What: String): Integer;
var
   i: Integer;
   found: Boolean;
Begin
     found := False;
     i := 1;
     Repeat
           If Where[i] = What[1] Then Begin
              If Copy(Where, i, Length(What)) = What Then Begin
                 found := True;
                 Result := i;
              end;
           end;
           Inc(i);
     Until (i > Length(Where)) Or found;
     If NOT found Then Result := -1;
end;

procedure _runasroot.DoRun;
var
  ErrorMsg: String;
begin
  // quick check parameters
  ErrorMsg:=CheckOptions('h','help');
  if ErrorMsg<>'' then begin
    ShowException(Exception.Create(ErrorMsg));
    Terminate;
    Exit;
  end;

  // parse parameters
  if HasOption('h','help') then begin
    WriteHelp;
    Terminate;
    Exit;
  end;

  If NOT SysUtils.FileExists(ParamStr(1)) Then Begin
     WriteLn('File does not exists.');
  end Else Begin
    TM := TMemoryStream.Create;
    TM.LoadFromFile(ParamStr(1));
    SetString(S, TM.Memory, TM.Size div SizeOf(Char));
    TM.Free;
    j := GetPos(S, geteuid);
    If j = -1 Then Begin
        WriteLn('Cannot find the protection.');
    end Else Begin
        WriteLn('Protection found at: 0x' + SysUtils.IntToHex(j - 1, 8));
        AssignFile(F, ParamStr(1));
        ReSet(F);
        Seek(F, j + 2);
        b := $70;
	Write(F, b);
        Write(F, b);
        CloseFile(F);
        WriteLn('Protection removed.');
    end;
  end;


  // stop program loop
  Terminate;
end;

constructor _runasroot.Create(TheOwner: TComponent);
begin
  inherited Create(TheOwner);
  StopOnException:=True;
end;

procedure _runasroot.WriteHelp;
begin
  WriteLn('"Run as root" - root protection remover by TCH');
  writeln('Usage: runasroot <filename>');
  WriteLn('E.g.: runasroot /usr/bin/vlc or runasroot /opt/google/chrome/chrome');
end;

var
  Application: _runasroot;

{$R *.res}

begin
  Application:=_runasroot.Create(nil);
  Application.Title:='run as root patch';
  Application.Run;
  Application.Free;
end.

